=== debian/changelog ===
madness (0.10.1+git20200818.eee5fd9f-2) unstable; urgency=medium

  [ Adrian Bunk ]
  * debian/patches/0001-Fix-madness-PNO-get_average_rank-on-32bit.patch: New
    patch, fixes FTBFS failure on 32bit architectures.
  * debian/patches/default_cxx_abi.patch: New patch, set fallback default C++
    ABI.

 -- Michael Banck <mbanck@debian.org>  Fri, 05 Feb 2021 11:16:17 +0100

madness (0.10.1+git20200818.eee5fd9f-1) unstable; urgency=medium

  * New upstream git snapshot.
  * debian/patches/cmake_installdir.patch: Updated.
  * debian/patches/relax_tbb_version_check.patch: Likewise.
  * debian/patches/cmake_mraplot_install.patch: Removed, no longer needed.
  * debian/patches/disable_pie.patch: Likewise.
  * debian/patches/cmake-syntax.patch: Likewise.
  * debian/rules (override_dh_auto_install): Run install-madness-libraries and
    install-madness-config targets explicitly.
  * debian/libmadness-dev.install: Install /usr/include/madness.h as well.
  * debian/rules (override_dh_auto_test): Strip test executables before running
    tests in order to cut down used disk space.

 -- Michael Banck <mbanck@debian.org>  Fri, 01 Jan 2021 19:27:59 +0100

madness (0.10.1~gite4aa500e-11) experimental; urgency=medium

  [ Debichem Team ]
  * Team upload.
  * Build using Python 3 (Closes: #943167).
  * Update Standards-Version to 4.4.1 (no changes required).
  * Add Rules-Requires-Root: no.
  * Add patch to fix cmake syntax error.

 -- Stuart Prescott <stuart@debian.org>  Fri, 10 Jan 2020 01:21:29 +1100
